<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("admin/include/lib-action/todos/ShowTodos.php");

class ShowDashboardTodos extends ShowTodos
{
	public function __construct()
	{
		parent::__construct();
		
		$this->params = array(
			"todoID",
			"productID",
			"todoTitle",
			"todoDesc",
			"userID",
			"todoStatusID",
			"todoDateDue",
			"todoDateCreated",
			"todoAssignedAdminID",
			"todoIsPublic");
		$this->sortColumns = array(
			"todoStatusID",
			"todoDateDue",
			"todoTitle",
			"userID",
			"todoAssignedAdminID",
			"todoIsPublic");
		$this->sortDir = "desc";
	}

	public function execute()
	{
		MB_Action::execute();
		
		// past due todo items
		$query = $this->getMBAPIQuery("GetTodos", "",
				array(
					"todoDateDueGreatest" => time(),
					"getAdminData" => 1,
					"numRecords" => 5,
					"sortDir" => "desc"));
		require_once("lib-mbapi/mbapi.php");
		$data = dispatchMBAPI($query, 1);
		$this->handleGroup( "pastdue", $data );

		$this->smartyVars["rowCount"]["pastdue"] = $this->getMaxCount( "pastdue" );
		
		
		// get todo's that are a day old
		$query = $this->getMBAPIQuery("GetTodos", "",
				array(
					"todoDateDueLeast" => time(),
					"todoDateDueGreatest" => time() + 86400,
					"getAdminData" => 1,
					"numRecords" => 5,
					"sortDir" => "desc"));
		$data = dispatchMBAPI($query, 1);
		$this->handleGroup( "near", $data );
		
		$this->smartyVars["rowCount"]["near"] = $this->getMaxCount( "near" );
		
		// defs
		$this->smartyVars["todostatus"] = getStatuses("todo");
		$this->smartyVars["todostatusheaders"] = array(
						"pastdue" => TRANS_DUE,
						"near" => TRANS_24HOURS);
		$this->smartyVars['todoAssignHeaders'] = array(
						'mine' => TRANS_MY_TODO_ITEMS,
						'public' => TRANS_PUBLIC);
					

		$data = arrayFor("admins", array("adminActive" => 1));
		
		if (is_array( $data ))
		foreach( $data as $admin ) {
			$this->smartyVars["adminsList"][ $admin["adminID"] ] = $admin["adminLastName"].", ".$admin["adminFirstName"];
		}
		
		if (!$this->_err) {
			$this->smartyVars = correctArray( $this->smartyVars );

			$this->addTemplate("dashboard/ShowDashboardTodos");
		}
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
