<?php
require_once("lib-action/action.php");
require_once("UI/Page.php");

class EditRegistrarConfigPage extends UIPage
{
	public function createControls()
	{
		require_once("ModuleTool.php");
		require_once("DataObject.php");


		$this->module_input_controls = array();

		$configGroup = Factory()->ConfigGroup($this->getValue("configGroupID"));

		if("godaddy" == $configGroup->config_group_name) {
			if("yes" != $configGroup->ConfigParams["moduleCertified"]->value) {
				$url = action_url("modules.php", "CertifyGoDaddyAccount", array("configGroupID" => $this->getValue("configGroupID")));
				$configGroup->ConfigParams["moduleCertified"]->value = '<div style=\'padding: 2px; font-weight: bold; border: 2px solid red;\'>'.blmsg("TRANS_NO").', <a href=\''.$url.'\'>'.blmsg("TRANS_COMPLETE_WWD_CERTIFICATION_PROCESS").'</a></div>';
			} else {
				$configGroup->ConfigParams["moduleCertified"]->value = blmsg("TRANS_YES");
			}
		}

		foreach (ModuleTool::getModuleControls("registrar", $configGroup->config_group_name) as $inputPanel) {
			$inputPanel->initFromArray(DataObject::getMapOf($configGroup->ConfigParams, "name", "value"));
			$this->module_input_controls = array_merge($this->module_input_controls, $inputPanel->getInputControls());
			if ( "" == $inputPanel->title ) {
				$inputPanel->title = blmsg("TRANS_CONFIGURATION_PARAMETERS");
			}
			$this->addInputPanel($inputPanel);
		}
	}

	public function processInput()
	{
		$configGroup = Factory()->ConfigGroup($this->getValue("configGroupID"));
		$configGroup->ConfigParams->clear();
		foreach ($this->module_input_controls as $control)
		{
			switch ($control->name)
			{
				case "modulePassword":
					require_once("lib-tk/include/crypt/crypt.php");
					if ("" != $control->value)
					{
						require_once("lib-tk/include/crypt/crypt.php");
						$configGroup->ConfigParams[$control->name]->value = getEncryptedText(getStuff($control->value));
					}
					break;
				default:
					$configGroup->ConfigParams[$control->name]->value = $control->value;
			}
		}

		if("godaddy" == $configGroup->config_group_name) {
			if(blmsg("TRANS_YES") == $configGroup->ConfigParams["moduleCertified"]->value) {
				$configGroup->ConfigParams["moduleCertified"]->value = 'yes';
			} else {
				$configGroup->ConfigParams["moduleCertified"]->value = 'no';
			}
		}

		try {
			$configGroup->ConfigParams->update();
			getCurrentSession()->Storage->infoMessages[] = blmsg("TRANS_SETTINGS_SAVED_SUCCESSFULLY");
		} catch (ProductException $e) {
			$this->addErrorMessage(UIFactory()->ErrorMessage($e->getMessage()));
		}

		return ! $this->hasWarnings() && ! $this->hasErrors();
	}

	private $module_input_controls;
}

class EditRegistrarConfig extends MB_Action
{
	public function execute()
	{
		parent::execute();

		if (!isset($_REQUEST['configGroupID'])) {
			$this->addError(TRANS_ACTIONERROR, "No Registrar given.");
			$this->addErrorTemplates();
			return $this->hasExecutedSuccessfully();
		}
		
		$configGroupID = bgpc("configGroupID");
		$back_url = action_url("registrars", "ShowRegistrars");
		$controller  = UIFactory()->PageController($back_url);
		$controller->addPage($edit_page = new EditRegistrarConfigPage($controller));
		$edit_page->title = blmsg("TRANS_REGISTRAR_OPTIONS");
		$edit_page->parent_title = blmsg("TRANS_MANAGE_SYSTEM");
		$edit_page->parent_url = $back_url;
		$controller->setValue("configGroupID", $configGroupID);
		$controller->processRequest();

		$this->smartyVars["page"] = $controller->getPage();
		$this->addTemplate("page");
		return $this->hasExecutedSuccessfully();
	}
}
?>