
<?php
require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/action.php");

class ShowPlanAddons extends MB_Action
{
	public function execute()
	{
		parent::execute();

		if (1 == bgpc("sync")) {
			$this->processSync();
		}

		$page  = UIFactory()->Page();
		$page->title = blmsg("TRANS_PLAN_ADDONS_TITLE");
		$page->parent_title = blmsg("TRANS_SHOW_PRODUCTS");
		$page->parent_url = action_url("products", "ShowProducts");

		require_once("UI/List/UIPlanAddonList.php");
		$page->addListPanel(new UIPlanAddonList());

		$this->smartyVars["page"] = $page;
		$this->addTemplate("page");
		return $this->hasExecutedSuccessfully();
	}

	private function processSync()
	{
		$addonIDs = bgpc("id", array());
		if (empty($addonIDs)) {
			return;
		}
		$errors = array();
		foreach ($addonIDs as $addonID) {
			try {
				$addon = Factory()->Product($addonID);
				$addon->sync_tasks |= Product::SYNC_NEED_REPAIR;
				require_once("object_managers/SyncManager.php");
				SyncManager::syncPlan($addon);
				if (!is_null($addon->sync_error)) {
					$errors[] = blmsg("TRANS_SYNC_PLAN_ADDON_ERROR_MSG", array("PLAN_ID" => $addon->id, "ERROR" => $addon->sync_error));
				}
			} catch (ProductException $e) {
				$errors[] = blmsg("TRANS_SYNC_PLAN_ADDON_ERROR_MSG", array("PLAN_ID" => $addonID, "ERROR" => $e->getMessage()));
			}
		}
		if (empty($errors)) {
			getCurrentSession()->Storage->infoMessages[] = blmsg("TRANS_SYNC_PLAN_ADDONS_SUCCESS_MSG");
		} else {
			getCurrentSession()->Storage->errorMessages[] = blmsg(
				"TRANS_SYNC_PLAN_ADDONS_FAILURE_MSG",
				array("ERROR" => billing_safetyhtml(implode("\n", $errors)))
			);
		}
	}
}
