<?php

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once dirname(__FILE__)."/Adapter.php";

class HSPC_PM_BT_Norma19 extends HSPC_PM_Adapter
{
	protected $secureFields = array("cif", "bank_agency_number", "bank_branch_number", "stored_control_dig", "account_number");

	protected $fieldsDescriptor = array(
		"billing_bank_name" => array(
			"holder_name" => "TRANS_BT_ACCOUNT_NORMA19__HOLDER_NAME"
		),
		"billing_bank_account_num" => array(
			"cif"					=> "TRANS_BT_ACCOUNT_NORMA19__CIF",
			"bank_agency_number"	=> "TRANS_BT_ACCOUNT_NORMA19__BANK_AGENCY_NUMBER",
			"bank_branch_number"	=> "TRANS_BT_ACCOUNT_NORMA19__BANK_BRANCH_NUMBER",
			"stored_control_dig"	=> "TRANS_BT_ACCOUNT_NORMA19__STORED_CONTROL_DIG",
			"account_number"		=> "TRANS_BT_ACCOUNT_NORMA19__ACCOUNT_NUMBER"
		)
	);

	public function validate()
	{
		$hspc_data = $this->getHSPCData();
		foreach ($hspc_data["public_data"] as $hspc_field => $hspc_data) {
			if (empty($hspc_data)) {
				return "One of the required data missing: {$hspc_field}";
			}
		}
		foreach ($hspc_data["secure_data"] as $hspc_field => $hspc_data) {
			if (empty($hspc_data)) {
				return "One of the required data missing: {$hspc_field}";
			}
		}
		return "OK";
	}

	protected function getLastFourDigit()
	{
		$hspc_data = $this->getHSPCData();
		$accountNumber = $hspc_data["secure_data"]["account_number"];
		return substr(preg_replace("/[^0-9]+/", "", $accountNumber), -4);
	}
}