<?php

require_once(dirname(__FILE__)."/ipnsetup.php");
require_once("UI/Page.php");
require_once("objects/Transaction.php");

class HSPCCallBackDetailsPage extends UIPage
{
	public function __construct(Transaction $transaction)
	{
		$this->transaction = $transaction;
	}

	public function getPageControlsHTML()
	{
		switch ($this->transaction->auth_return) {
		case Transaction::STATUS_SUCCESSFUL_CHARGE:
			$title = "<font color='darkblue'>".strtoupper(blmsg("TRANS_CALLBACK_PAYMENT_STATUS_ACCEPTED_TITLE"))."</font>";
			break;
		case Transaction::STATUS_DECLINED_CHARGE:
			$title = "<font color='red'>".strtoupper(blmsg("TRANS_CALLBACK_PAYMENT_STATUS_DECLINED_TITLE"))."</font>";
			break;
		default:
			$title = "<font color='red'>".strtoupper(blmsg("TRANS_CALLBACK_PAYMENT_STATUS_ERRORED_TITLE"))."</font>";
		}

		$header_style = "border-bottom: 2px solid #999999;background-color:#eeeeee;font-weight:bold;color:#555555;";
		$title_style = "background-color:#eeeeee;font-weight:bold;color:#555555;";
		$text_style = "border-left: 1px solid #999999;";

		require_once("BillingLocale.php");

		return "
			<center>
			<p><strong><font style='font-size:14pt;'>{$title}</font></strong></p>
			<br/></br>
			<style>
				#transDetails {
					width: 500px;
					border: 2px solid #999999;
				}
				#transDetails td {
					padding: 6px !important;
				}
			</style>
			<table border='0' cellspacing='0' id='transDetails'>
				<tr><td colspan='2' style='{$header_style}'>".strtoupper(blmsg("TRANS_CALLBACK_PAYMENT_INFO_TITLE"))."</td></tr>
				<tr><td style='{$title_style}'>".
					blmsg("TRANS_TRANSACTION_GATEWAY")."</td><td style='{$text_style} border-bottom:1px solid #999999'>".
					Factory()->PaymentGateway($this->transaction->payment_gateway_id)->payment_gateway_name."&nbsp;</td></tr>
				<tr><td style='{$title_style}'>".
					blmsg("TRANS_TRANSACTION_DATETIME")."</td><td style='{$text_style}'>".
					billing_get_user_locale()->getLocaleDateTime($this->transaction->transaction_date_created, "medium")."&nbsp;</td></tr>
				<tr><td style='{$title_style}'>".
					blmsg("TRANS_TRANSACTION_ID")."</td><td style='{$text_style} border-bottom:1px solid #999999'>".
					$this->transaction->id."&nbsp;</td></tr>
				<tr><td style='{$title_style}'>".
					blmsg("TRANS_TRANSACTION_AMOUNT")."</td><td style='{$text_style}'>".
					BillingLocale::getCurrency($this->transaction->transaction_amount, $this->transaction->currency_id) ."&nbsp;</td></tr>
				<tr><td style='{$title_style}'>".
					blmsg("TRANS_TRANSACTION_NOTES")."</td><td style='{$text_style}'>".
					$this->transaction->transaction_notes."&nbsp;</td></tr>
			</table>
			</center>
		";
	}

	private $transaction;
}

try {
	dbg("REMOTE_ADDR:REMOTE_PORT:");
	dbg("{$_SERVER['REMOTE_ADDR']}:{$_SERVER['REMOTE_PORT']}");
	dbg("REQUEST_URI:");
	dbg($_SERVER["REQUEST_URI"]);
	dbg("REQUEST:");
	dbg($_REQUEST);
	require_once("object_managers/PaymentManager.php");
	$page = new HSPCCallBackDetailsPage(PaymentManager::processCallback($_SERVER["REQUEST_URI"], bgpc_stripslashes($_REQUEST)));
	echo $page->getHTML(true);
} catch (Exception $e) {
	dbg("Failed to process callback from '{$_SERVER['REMOTE_ADDR']}:{$_SERVER['REMOTE_PORT']}': {$e->getMessage()}");
}
